<?php
// xeCMS 1.0.0
// (C) 2003-2005 xetna scripting
// http://xecms.sunsite.dk

// this file contains functions used for creating, editing, and deleting content files

// creates file
function createfile ($page)
{
	// create the page
	touch("./content/$page.php");
}

// adds file link to navigation
function addnavlink ($page, $title, $siteurl)
{
	if (is_writable("./content/nav/nav.php")) {
		if (!$fp = fopen("./content/nav/nav.php", 'a')) {
			echo "Cannot open file ./content/nav/nav.php";
			exit;
		}

		if (fwrite($fp, stripslashes("<a href=\"$siteurl/index.php?p=$page\">$title</a><br /> \n")) === FALSE) {
			echo "Cannot write to file ./content/nav/nav.php";
			exit;
		}
    
		fclose($fp);

	} else {
		echo "The file ./content/nav/nav.php is not writable";
	}
}

// function from http://photomatt.net/scripts/autop with auto-paragraph removed
// this automatically inserts <br /> and doesn't mess up if a <br /> already exists like nl2br()
function autobr($pee, $br = 1) {
    $pee = preg_replace('!(<(?:table|ul|ol|li|pre|form|blockquote|h[1-6])[^>]*>)!', "\n$1", $pee); // Space things out a little
    $pee = preg_replace('!(</(?:table|ul|ol|li|pre|form|blockquote|h[1-6])>)!', "$1\n", $pee); // Space things out a little
    $pee = preg_replace("/(\r\n|\r)/", "\n", $pee); // cross-platform newlines
    $pee = preg_replace("/\n\n+/", "\n\n", $pee); // take care of duplicates
    if ($br) $pee = preg_replace('|(?<!<br />)\s*\n|', "<br />\n", $pee); // optionally make line breaks
    $pee = preg_replace('!(</?(?:table|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|form|blockquote|p|h[1-6])[^>]*>)\s*<br />!', "$1", $pee);
    $pee = preg_replace('!<br />(\s*</?(?:p|li|div|th|pre|td|ul|ol)>)!', '$1', $pee);
    $pee = preg_replace('/&([^#])(?![a-z]{1,8};)/', '&#038;$1', $pee);
   
    return $pee;
}


// updates file content
function updatecontent ($page, $content, $autobr)
{
	// if auto-br is on, convert linebreaks to <br />s
	if ($autobr == "yes")
	{
		$content = autobr($content);
	}

	if (is_writable("./content/$page.php")) {
		if (!$fp = fopen("./content/$page.php", 'w')) {
			echo "Cannot open file ./content/$page.php";
			exit;
		}

		if (fwrite($fp, stripslashes($content)) === FALSE) {
			echo "Cannot write to file ./content/$page.php";
			exit;
		}
    
		fclose($fp);

	} else {
		echo "The file ./content/$page.php is not writable";
	}
}

// deletes file - having a function for this may seem stupid, but it allows for easy modifications and/or database conversions
function delfile ($page)
{
	// delete the file
	unlink("./content/$page.php");
}

// readfile is used in the edit page textarea because php is shown rather than executed
// readfile_chunked() is by "Rob Funk" and can be found on the php manual's readfile page
// it prevents possible problems with getting large files with readfile
function readfile_chunked ($filename) {
  $chunksize = 1*(1024*1024); // how many bytes per chunk
  $buffer = '';
  $handle = fopen($filename, 'rb');
  if ($handle === false) {
   return false;
  }
  while (!feof($handle)) {
   $buffer = fread($handle, $chunksize);
   
   print $buffer;
  }
  return fclose($handle);
}

// this array search function searches the array for $needle but doesn't require an exact match
// function is by "mjwilco at yahoo dot com", and available on the php manual array_search page
function array_search_bit($search, $array_in)
{
   foreach ($array_in as $key => $value)
   {
   if (strpos($value, $search) !== FALSE)
   return $key;
   }
  
   return FALSE;
}

function removenavlink ($page, $siteurl)
{
	// put file contents into $array
	$array = file("./content/nav/nav.php");

	// set needle, the string that is searched for in $array
	$needle = "<a href=\"$siteurl/index.php?p=" . $page . "\">";

	// get key of the line we want to delete
	$key = array_search_bit($needle, $array);

	// delete line
	unset($array[$key]);

	// put new navigation into string
	$str = implode("", $array);

	// check if file is writable
	if (is_writable("./content/nav/nav.php")) {
		// open file
   		if (!$fp = fopen("./content/nav/nav.php", "w")) {
         	echo "Cannot open file ./content/nav/nav.php";
         	exit;
   		}
		// write file
   		if (fwrite($fp, $str) === FALSE) {
       		echo "Cannot write to file ./content/nav/nav.php";
       		exit;
  		 }
  		
   		// close file
   		fclose($fp);

	} else {
   		echo "The file ./content/nav/nav.php is not writable";
	}

}

?>